// ============================================================================
// $Id: ClasspathSuite.java,v 1.1 2003/04/20 02:57:16 davidahall Exp $
// Copyright (c) 2003  David A. Hall
// ============================================================================
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// ============================================================================
package tools;

import java.util.Enumeration;
import junit.framework.TestSuite;
import junit.runner.BaseTestRunner;
// import junit.runner.ClassPathTestCollector;
// import junit.runner.LoadingTestCollector;
import junit.runner.SimpleTestCollector;
import junit.runner.TestCollector;


/**
 * ClasspathSuite.java
 *
 * @author <a href="mailto:davidahall@users.sf.net">David A. Hall</a>
 * @version
 */

public class ClasspathSuite extends TestSuite {
    
	static private final String TESTCOLLECTOR_KEY= "TestCollectorClass";
    
    static public TestSuite suite() {
        TestSuite suite = new TestSuite();
        TestCollector collector = createTestCollector(); // see TestRunner
        Enumeration enum = collector.collectTests();
        while(enum.hasMoreElements()) {
            String classname = (String) enum.nextElement();
            try {
                suite.addTestSuite(Class.forName(classname));
            }
            catch (ClassNotFoundException x) { x.printStackTrace(); }
        }
        
        return suite;        
    }

	static TestCollector createTestCollector() {
        String className= BaseTestRunner.getPreference(TESTCOLLECTOR_KEY);
		if (className != null) {			
			Class collectorClass= null;
			try {
				collectorClass= Class.forName(className);
				return (TestCollector)collectorClass.newInstance();
			} catch(Exception e) {
				System.out.println("Could not create TestCollector - using default collector");
                e.printStackTrace();
			}
		}
		return new SimpleTestCollector();
	}

    public void testBogus() {}
}
